module.exports = function (bin) {
    require('./header')(bin);
    // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    bin.File = function(binary, header) {
        this.header = header;
        this.binary = binary;
        this.extractProperties  = function(binary) {
            if (!binary) binary = this.binary;
            if (binary != null && binary.length >= this.header.def.length) {
                this.header.def.map.forEach (function(prop) {
                    var bytes    = binary.slice(prop.offset, prop.offset+prop.length);
                    var unpacked = bin.unpack(prop.size, prop.type, bytes);
                    prop.value = unpacked;
                });
            }
        };
        this.buildProperties = function(properties) {
            var data = [];
            this.header.buildProperties(properties);
            this.header.def.map.forEach (function(prop) {
                var packed = bin.pack(prop.size, prop.type, prop.value);
                data.push(packed);
            });
            data = bin.mergeBuffers(data);
        };
        this.extractProperties(binary);
    }
    // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    bin.smpFile = function(binary) {
        return new bin.File(binary, new bin.Header([
            ['signature', 'a',  9, '∢SMP0.2'],
            ['size'     , 'N',  1, ''],
            ['id'       , 'N',  1, ''],
            ['from'     , 'a', 32, ''],
            ['to'       , 'a', 32, ''],
            ['channel'  , 'a', 32, ''],
            ['command'  , 'n',  1, ''],
            ['index'    , 'n',  1, ''],
            ['split'    , 'n',  1, '']
        ]));
    }
    // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    bin.smpsFile = function(binary) {
        return new bin.File(binary, new bin.Header([
            ['signature', 'a',  13, 'ﷸSMPS0.2∢'],
            ['size'     , 'N',   1, ''],
            ['nonce'    , 'a',  12, ''],
            ['cypher'   , 'a', 135, '']
        ]));
    }
    // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    bin.smpaFile = function(binary) {
        return new bin.BaseFile(binary, new bin.Header([
            ['signature', 'a',  13, 'ﷸSMPA0.2∢'],
            ['size'     , 'N',   1, ''],
            ['nonce'    , 'a',  24, ''],
            ['cypher'   , 'a', 199, '']
        ]));
    }
}
